
gMusicFromLocalMenu = false
 
sc_Music_SaveError = function()
  if MODEL.oasis.media.audioplayer.was_saveerror() then
    MODEL.screen.msgbox.new.setup(1)
    MODEL.screen.msgbox.new.set_line(1, m_i18n("Save failed. The reason can be media surface error, write protection or the media is full. Please retry!"))
    MODEL.screen.msgbox.new.setup_button(1, "", m_i18n("OK"), "", "ico_done_mid.bmp#3")
    MODEL.screen.msgbox.create_new()
    oasis.media.audioplayer.was_saveerror = false
  end
end
 
createState("st_Music")
st_Music:useLayers(backgroundLayers, "ui_Music", "ui_MediaScanning", localMenuLayers)
st_Music.enter = function()
  MODEL.oasis.media.audioplayer.allow_calculating = true
  MODEL.oasis.media.audioplayer.start_calculating()
  MODEL.oasis.media.audioplayer.remove_not_existing()
  MODEL.oasis.media.audioplayer.playmode = PERSISTENT.gMusicPlaymode()
  MODEL.oasis.media.audioplayer.repeatmode = PERSISTENT.gMusicRepeatmode()
end
 
st_Music.init = function()
  txtTitle.TEXT = m_i18n("Music Player")
  obs_Music_MediaScan_SDCardInserted:START("NO_TRIGGER")
  obs_Music_MediaScan_SDCardRemoved:START("NO_TRIGGER")
  obs_Music_MediaScan_Finished:START("NO_TRIGGER")
  if not MODEL.oasis.media.audioplayer.is_playing() then
    if not MODEL.oasis.media_scan.sdcard_inserted() then
      MODEL.oasis.media.audioplayer.remove_not_existing()
    elseif MODEL.oasis.media_scan.isdirty() then
      sc_Music_MediaScan_SDCardInserted()
    end
  end
  sc_init_local_menu("ui.musicplayer_settings")
end
 
st_Music.done = function()
  obs_Music_MediaScan_SDCardInserted:STOP()
  obs_Music_MediaScan_SDCardRemoved:STOP()
  obs_Music_MediaScan_Finished:STOP()
end
 
st_Music.exit = function()
  MODEL.oasis.media.audioplayer.allow_calculating = false
  if MODEL.oasis.media.audioplayer.is_playing() and not MODEL.oasis.media.audioplayer.is_paused() and gMusicFromLocalMenu == false then
    if PERSISTENT.vMusic_PlayAfterExit() == "ASK" then
      MODEL.screen.msgbox.new.setup(2)
      MODEL.screen.msgbox.new.set_line(1, m_i18n("Do you want to continue playing music?"))
      MODEL.screen.msgbox.new.setup_button(1, "", m_i18n("Continue Playing"), "", "ico_done_mid.bmp#3")
      MODEL.screen.msgbox.new.setup_button(2, "sc_MediaStop", m_i18n("Stop"), "", "ico_cancel_mid.bmp#3")
      MODEL.screen.msgbox.create_new()
    end
    if PERSISTENT.vMusic_PlayAfterExit() == "NO" then
      sc_MediaStop()
    end
  end
  MODEL.lua.zz_lastIndex = MODEL.oasis.media.audioplayer.list.index()
end
  
sc_map_local_menu_music = function()
  sc_NextStateAnim(st_Music, "horz_scroll", 1, "")
  gMusicFromLocalMenu = true
end
 
sc_MediaOnAdvance = function()
end
 
sc_MediaPlay = function()
  if #MODEL.oasis.media.audioplayer.list then
    MODEL.oasis.media.audioplayer.play()
  end
end
 
sc_MediaStop = function()
  MODEL.oasis.media.audioplayer.stop()
  if MODEL.lua.zz_PLSShowSS() then
	MODEL.lua.zz_PLSShowSS = false
  end
end
 
sc_MediaPause = function()
  MODEL.oasis.media.audioplayer.pause()
end
 
sc_MediaUnpause = function()
  MODEL.oasis.media.audioplayer.unpause()
end
 
sc_Music_MediaScan_Init = function()
  if MODEL.oasis.media_scan.isdirty() then
    sc_Music_MediaScan_Init2()
  end
end
 
sc_Music_MediaScan_Init2 = function()
  local mediaScan = MODEL.oasis.media_scan()
  mediaScan.isunsortedlast = true
  mediaScan.filter = L"fcategory:0;fcategory:5"
  mediaScan.display_format = "$Title$"
  mediaScan.filter_type = L"MUSIC"
  mediaScan.start()
end
 
sc_Music_MediaScan_Finished = function()
  MODEL.oasis.media.audioplayer.remove_not_existing()
  if not #MODEL.oasis.media.audioplayer.list then
    sc_Music_MediaScan_Finished_FillEmptyList()
  end
end
 
sc_Music_MediaScan_Finished_FillEmptyList = function()
  local mediaScan = MODEL.oasis.media_scan()
  local audioPlayer = MODEL.oasis.media.audioplayer()
  mediaScan.groupby = L";ext:-m3u"
  mediaScan.group()
  mediaScan.select_all()
  audioPlayer.clear()
  audioPlayer.add_media_scan_list()
  if #audioPlayer.list then
    audioPlayer.save(L"lastlist.m3u.sav")
  end
end
 
sc_Music_MediaScan_SDCardInserted = function()
  local audioPlayer = MODEL.oasis.media.audioplayer()
  MODEL.oasis.media_scan.cancel()
  audioPlayer.stop()
  audioPlayer.clear()
  audioPlayer.load(L"lastlist.m3u.sav")
  audioPlayer.remove_not_existing()
  if not #audioPlayer.list then
    sc_Music_MediaScan_Init()
  end
  MODEL.oasis.media.audioplayer.list.index = MODEL.lua.zz_lastIndex()
end
 
sc_Music_MediaScan_SDCardRemoved = function()
  MODEL.oasis.media.audioplayer.remove_not_existing()
  if not #MODEL.oasis.media.audioplayer.list then
    sc_Music_MediaScan_Init()
  end
end
 
createState("st_MusicMenu")
st_MusicMenu:useLayers(backgroundLayers, "ui_MusicMenu")
st_MusicMenu.init = function()
  txtTitle.TEXT = m_i18n("Music Library")
  gMediaScanTitleStack = {}
end

  
sc_MusicMenu_AddSongs = function()
  MODEL.oasis.media_scan.groupby = L";ext:-m3u"
  table.insert(gMediaScanTitleStack, m_i18n("Songs"))
  sc_NextStateAnim(st_FilesMediaScan, "horz_scroll", 1, "")
end
 
sc_MusicMenu_AddArtists = function()
  MODEL.oasis.media_scan.groupby = L"ID3~Artist,14,ID3~Album,15;ext:-m3u"
  table.insert(gMediaScanTitleStack, m_i18n("Artists"))
  sc_NextStateAnim(st_FilesMediaScan, "horz_scroll", 1, "")
end
 
sc_MusicMenu_AddAlbums = function()
  MODEL.oasis.media_scan.groupby = L"ID3~Album,15;ext:-m3u"
  table.insert(gMediaScanTitleStack, m_i18n("Albums"))
  sc_NextStateAnim(st_FilesMediaScan, "horz_scroll", 1, "")
end
 
createState("st_SoundTone")
st_SoundTone:useLayers(backgroundLayers, "ui_SoundTone")
createState("st_SoundEQ")
st_SoundEQ:useLayers(backgroundLayers, "ui_SoundEQ")
sc_PlayerSettings = function()
  sc_close_local_menu()
  sc_NextStateAnim(st_PlayerSettings, "vert_scroll", 1, "")
end
 
createState("st_PlayerSettings")
st_PlayerSettings:useLayers(backgroundLayers, "ui_PlayerSettings", ui_List_Background)
st_PlayerSettings.init = function()
  txtTitle.TEXT = m_i18n("Music Player Settings")
end
 
st_PlayerSettings.done = function()
  PERSISTENT.gMusicPlaymode = MODEL.oasis.media.audioplayer.playmode()
  PERSISTENT.gMusicRepeatmode = MODEL.oasis.media.audioplayer.repeatmode()
end
 
sc_IdTag = function()
  sc_close_local_menu()
  sc_NextStateAnim(st_IdTag, "vert_scroll", 1, "")
end
 
createState("st_IdTag")
st_IdTag:useLayers(backgroundLayers, "ui_IdTag", ui_List_Background)
st_IdTag.init = function()
  txtTitle.TEXT = m_i18n("Show ID3 Tag")
end
